Index: orxonox/branches/buerli/src/world.cc
===================================================================
--- orxonox/branches/buerli/src/world.cc	(revision 2706)
+++ orxonox/branches/buerli/src/world.cc	(revision 2707)
@@ -31,7 +31,16 @@
     This creates a new empty world!
 */
-World::World ()
-{
-  entities = new List<WorldEntity>();
+World::World (char* name)
+{
+  this->worldName = name;
+  this->debugWorldNr = -1;
+  this->entities = new List<WorldEntity>();
+}
+
+World::World (int worldID)
+{
+  this->debugWorldNr = worldID;
+  this->worldName = NULL;
+  this->entities = new List<WorldEntity>();
 }
 
@@ -41,7 +50,125 @@
 World::~World ()
 {
-  unload ();
-  delete entities;
-}
+  Orxonox *orx = Orxonox::getInstance();
+  orx->get_localinput()->unbind (this->localPlayer);
+  delete this->entities;
+  delete this->localCamera;
+}
+
+
+/** 
+    \brief initialize the world before use.
+*/
+Error World::init()
+{
+  this->bPause = false;
+}
+
+Error World::start()
+{
+  this->mainLoop();
+}
+
+Error World::stop()
+{
+  this->bQuitCurrentGame = true;
+  this->localCamera->setWorld(NULL);
+  this->~World();
+}
+
+Error World::pause()
+{
+  this->isPaused = true;
+}
+
+Error World::resume()
+{
+  this->isPaused = false;
+}
+
+void World::load()
+{
+  if(this->debugWorldNr != -1)
+    {
+      switch(this->debugWorldNr)
+	{
+	case DEBUG_WORLD_0:
+	  {
+	    // create some path nodes
+	    this->pathnodes = new Vector[6];
+	    this->pathnodes[0] = Vector(0, 0, 0);
+	    this->pathnodes[1] = Vector(-100, 40, 0);
+	    this->pathnodes[2] = Vector(-100, 140, 0);
+	    this->pathnodes[3] = Vector(0, 180, 0);
+	    this->pathnodes[4] = Vector(100, 140, 0);
+	    this->pathnodes[5] = Vector(100, 40, 0);
+	    
+	    // create the tracks
+	    this->tracklen = 6;
+	    this->track = new Track[6];
+	    for( int i = 0; i < this->tracklen; i++)
+	      {
+		this->track[i] = Track( i, (i+1)%this->tracklen, &this->pathnodes[i], &this->pathnodes[(i+1)%this->tracklen]);
+	      }
+	    
+	    // create a player
+	    //WorldEntity* myPlayer = (WorldEntity*) this->spawn<Player>();
+	    WorldEntity* myPlayer = new Player();
+	    this->spawn(myPlayer);
+	    this->localPlayer = myPlayer;	    
+
+	    // bind input
+	    Orxonox *orx = Orxonox::getInstance();
+	    orx->get_localinput()->bind (myPlayer);
+	    
+	    // bind camera
+	    this->localCamera = new Camera(this);
+	    this->getCamera()->bind (myPlayer);	
+	    break;
+	  }
+	case DEBUG_WORLD_1:
+	  {
+	    // create some path nodes
+	    this->pathnodes = new Vector[6];
+	    this->pathnodes[0] = Vector(0, 0, 0);
+	    this->pathnodes[1] = Vector(20, 10, 10);
+	    this->pathnodes[2] = Vector(40, 0, 10);
+	    this->pathnodes[3] = Vector(60, 10, 0);
+	    this->pathnodes[4] = Vector(80, 20, 10);
+	    this->pathnodes[5] = Vector(30, 50, 0);
+	    
+	    // create the tracks
+	    this->tracklen = 6;
+	    this->track = new Track[6];
+	    for( int i = 0; i < this->tracklen; i++)
+	      {
+		this->track[i] = Track( i, (i+1)%this->tracklen, &this->pathnodes[i], &this->pathnodes[(i+1)%this->tracklen]);
+	      }
+	    
+	    // create a player
+	    //WorldEntity* myPlayer = (WorldEntity*) this->spawn<Player>();
+	    WorldEntity* myPlayer = new Player();
+	    this->spawn(myPlayer);
+	    this->localPlayer = myPlayer;
+	    
+	    // bind input
+	    Orxonox *orx = Orxonox::getInstance();
+	    orx->get_localinput()->bind (myPlayer);
+	    
+	    // bind camera
+	    this->localCamera = new Camera(this);
+	    this->getCamera()->bind (myPlayer);	
+	    break;
+	  }
+	default:
+	  printf("World::load() - no world with ID %i found", this->debugWorldNr );
+	}
+    }
+  else if(this->worldName != NULL)
+    {
+
+    }
+}
+
 
 /** 
@@ -254,36 +381,5 @@
 }
 
-/**
-   \brief loads a simple level for testing purposes
-*/
-void World::load_debug_level()
-{
-  // create some path nodes
-  pathnodes = new Vector[6];
-  pathnodes[0] = Vector(0, 0, 0);
-  pathnodes[1] = Vector(-100, 40, 0);
-  pathnodes[2] = Vector(-100, 140, 0);
-  pathnodes[3] = Vector(0, 180, 0);
-  pathnodes[4] = Vector(100, 140, 0);
-  pathnodes[5] = Vector(100, 40, 0);	
-  
-  // create the tracks
-  tracklen = 6;
-  track = new Track[6];
-  for( int i = 0; i < tracklen; i++)
-    {
-      track[i] = Track( i, (i+1)%tracklen, &pathnodes[i], &pathnodes[(i+1)%tracklen]);
-    }
-  
-  // create a player
-  WorldEntity* myPlayer = (WorldEntity*) spawn<Player>();
-  
-  // bind input
-  Orxonox *orx = Orxonox::getInstance();
-  orx->get_localinput()->bind (myPlayer);
-  
-  // bind camera
-  orx->get_camera()->bind (myPlayer);
-}
+
 
 /**
@@ -295,2 +391,168 @@
   track[loc->part].map_camera (loc, plc);
 }
+
+
+void World::setTrackLen(Uint32 len)
+{
+  this->tracklen = len;
+}
+
+int World::getTrackLen()
+{
+  return this->tracklen;
+}
+
+void World::debug()
+{
+  List<WorldEntity> *l;
+  WorldEntity* entity;
+  
+  printf("counting all entities\n");
+  l = entities->get_next();  
+  while( l != NULL ) 
+    { 
+      entity = l->get_object();
+      if( entity->bDraw ) printf("got an entity\n");
+      l = l->get_next();
+    }
+}
+
+
+void World::mainLoop()
+{
+  this->lastFrame = SDL_GetTicks();
+  this->bQuitOrxonox = false;
+  this->bQuitCurrentGame = false;
+  printf("World|Entering main loop\n");
+  while(!this->bQuitOrxonox && !this->bQuitCurrentGame) /* pause pause pause ?!?!?*/
+    {
+      //debug routine
+      //debug();
+      // Network
+      synchronize();
+      // Process input
+      handle_input();
+      // Process time
+      time_slice();
+      // Process collision
+      collision();
+      // Draw
+      display();
+    }
+  printf("World|Exiting the main loop\n");
+}
+
+/**
+   \brief synchronize local data with remote data
+*/
+void World::synchronize ()
+{
+  // Get remote input
+  // Update synchronizables
+}
+
+/**
+   \brief run all input processing
+*/
+void World::handle_input ()
+{
+  // localinput
+  Orxonox::getInstance()->get_localinput()->process();
+  // remoteinput
+}
+
+/**
+   \brief advance the timeline
+*/
+void World::time_slice ()
+{
+  Uint32 currentFrame = SDL_GetTicks();
+  if(!this->bPause)
+    {
+      Uint32 dt = currentFrame - this->lastFrame;
+      /*
+      if(dt > 0)
+	{
+	  float fps = 1000/dt;
+	  printf("fps = %f\n", fps);
+	}
+      else
+	{
+	  printf("fps = 1000\n");
+	}
+      */
+      this->time_slice (dt);
+      this->update ();
+      this->localCamera->time_slice (dt);
+    }
+  this->lastFrame = currentFrame;
+}
+
+/**
+   \brief compute collision detection
+*/
+void World::collision ()
+{
+  this->collide ();
+}
+
+/**
+   \brief handle keyboard commands that are not meant for WorldEntities
+   \param cmd: the command to handle
+   \return true if the command was handled by the system or false if it may be passed to the WorldEntities
+*/
+bool World::system_command (Command* cmd)
+{
+  if( !strcmp( cmd->cmd, "quit"))
+    {
+      if( !cmd->bUp) this->bQuitOrxonox = true;
+      return true;
+    }
+  return false;
+}
+
+/**
+	\brief render the current frame
+*/
+void World::display ()
+{
+  // clear buffer
+  glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
+  // set camera
+  this->localCamera->apply ();
+  // draw world
+  this->draw();
+  // draw HUD
+  // flip buffers
+  SDL_GL_SwapBuffers();
+}
+
+Camera* World::getCamera()
+{
+  return this->localCamera;
+}
+
+
+void World::spawn(WorldEntity* entity)
+{
+  Location zeroloc;
+  Location* loc = NULL;
+  WorldEntity* owner;
+  //T* entity = new T();
+  entities->add (entity, LIST_ADD_NEXT);
+  //if( loc == NULL)
+  //{
+      zeroloc.dist = 0;
+      zeroloc.part = 0;
+      zeroloc.pos = Vector();
+      zeroloc.rot = Quaternion();
+      loc = &zeroloc;
+      //}
+  entity->init (loc, owner);
+  if (entity->bFree)
+    {
+      this->track[loc->part].map_coords( loc, entity->get_placement());
+    }
+  entity->post_spawn ();
+  //return entity;
+}
Index: orxonox/branches/buerli/src/world.h
===================================================================
--- orxonox/branches/buerli/src/world.h	(revision 2706)
+++ orxonox/branches/buerli/src/world.h	(revision 2707)
@@ -8,39 +8,75 @@
 
 #include "stdincl.h"
+#include "story_entity.h"
+
+
 
 class Track;
 class WorldEntity;
+class Camera;
 
 //! The game environment
-class World {
+class World : public StoryEntity {
 
  public:
-  World ();
+  World (char* name);
+  World (int worldID);
   ~World ();
 
-	template<typename T> 
-	  T* spawn(Location* loc, WorldEntity* owner);	// template to be able to spawn any derivation of WorldEntity
-	template<typename T> 
-	  T* spawn(Placement* plc, WorldEntity* owner);
+  template<typename T> 
+    T* spawn(Location* loc, WorldEntity* owner);	// template to be able to spawn any derivation of WorldEntity
+  template<typename T> 
+    T* spawn(Placement* plc, WorldEntity* owner);
+  
+  virtual Error init();
+  virtual Error start();
+  virtual Error stop();
+  virtual Error pause();
+  virtual Error resume();
 
-	void time_slice (Uint32 deltaT);
-	void collide ();
-	void draw ();
-	void update ();	// maps Locations to Placements
-	void calc_camera_pos (Location* loc, Placement* plc);
+  virtual void load();
+
+  void time_slice (Uint32 deltaT);
+  void collide ();
+  void draw ();
+  void update ();	// maps Locations to Placements
+  void calc_camera_pos (Location* loc, Placement* plc);
 	
-	void unload ();
-	
-	void load_debug_level ();
-	
+  void unload ();
+  
+  void setTrackLen(Uint32 tracklen);
+  int getTrackLen();
+  bool system_command (Command* cmd);
+  Camera* getCamera();
+  //private:
+
+  void spawn(WorldEntity* entity);
+
+  List<WorldEntity>* entities;
+  
+  // base level data
+  Track* track;
+  Uint32 tracklen;   // number of Tracks the World consist of
+  Vector* pathnodes;
+  Camera* localCamera;  
+
  private:
- 
-	List<WorldEntity>* entities;
-	
-		// base level data
-	Track* track;
-	Uint32 tracklen;   // number of Tracks the World consist of
-	Vector* pathnodes;
+  Uint32 lastFrame; //!> last time of frame
+  bool bQuitOrxonox; //!> quit this application
+  bool bQuitCurrentGame; //!> quit only the current game and return to menu
+  bool bPause;
 
+  char* worldName;
+  int debugWorldNr;
+
+  WorldEntity* localPlayer;
+  
+  void mainLoop();
+  void synchronize();
+  void handle_input();
+  void time_slice();
+  void collision();
+  void display();
+  void debug();
 };
 
@@ -58,22 +94,22 @@
 template<typename T> T* World::spawn(Location* loc = NULL, WorldEntity* owner = NULL)
 {
-	Location zeroloc;
-	T* entity = new T();
-	entities->add ((WorldEntity*)entity, LIST_ADD_NEXT);
-	if( loc == NULL)
-	{
-		zeroloc.dist = 0;
-		zeroloc.part = 0;
-		zeroloc.pos = Vector();
-		zeroloc.rot = Quaternion();
-		loc = &zeroloc;
-	}
-	entity->init (loc, owner);
-	if (entity->bFree)
-	{
-		track[loc->part].map_coords( loc, entity->get_placement());
-	}
-	entity->post_spawn ();
-	return entity;
+  Location zeroloc;
+  T* entity = new T();
+  entities->add ((WorldEntity*)entity, LIST_ADD_NEXT);
+  if( loc == NULL)
+    {
+      zeroloc.dist = 0;
+      zeroloc.part = 0;
+      zeroloc.pos = Vector();
+      zeroloc.rot = Quaternion();
+      loc = &zeroloc;
+    }
+  entity->init (loc, owner);
+  if (entity->bFree)
+    {
+      track[loc->part].map_coords( loc, entity->get_placement());
+    }
+  entity->post_spawn ();
+  return entity;
 }
 
@@ -92,15 +128,15 @@
 template<typename T> T* World::spawn(Placement* plc, WorldEntity* owner = NULL)
 {
-	T* entity = new T();
-	entities->add ((WorldEntity*)entity, LIST_ADD_NEXT);
-	entity->init (plc, owner);
-	if (!entity->bFree)
-	{
-		printf("Can't spawn unfree entity with placement\n"); 
-		entities->remove( (WorldEntity*)entity, LIST_FIND_FW);
-		return NULL;
-	}
-	entity->post_spawn ();
-	return entity;
+  T* entity = new T();
+  entities->add ((WorldEntity*)entity, LIST_ADD_NEXT);
+  entity->init (plc, owner);
+  if (!entity->bFree)
+    {
+      printf("Can't spawn unfree entity with placement\n"); 
+      entities->remove( (WorldEntity*)entity, LIST_FIND_FW);
+      return NULL;
+    }
+  entity->post_spawn ();
+  return entity;
 }
 
